from tensorflow.keras import Sequential
from tensorflow.keras.layers import (Dense, Flatten, Reshape)

SEED = 12345678


def create_model(model_type='conv', n_outputs=10, reg_coeff=0.01):
  if model_type == 'naive':
    return _naive_model(n_outputs=n_outputs)
  if model_type == 'conv':
    return _conv_model(n_outputs=n_outputs)
  if model_type == 'mlp':
    return _mlp_model(n_outputs=n_outputs)


def _naive_model(n_outputs=10):
  """Naive model using only 1 FC layer, no dropout. For reference purpose. 
    Validation and Test accuracy should be around 26%. 
  """
  return Sequential([
    Reshape((-1, 32 * 32 * 3)),
    Dense(n_outputs, activation='softmax')
  ])


def _conv_model(n_outputs=10):
  """
  From a batch of input images (B x H W C), return a logits (vector 
  of n_classes) 
  
  - Build several stacked convolutional layers (2D) 
  - Place pooling layers properly in between 
  - If is_train: then activate dropout appropriately  
  
  Note: any usage of tf.contrib.slim prebuilt layers is invalid. 
  """
  # TODO: implement your model here
  return None


def _mlp_model(n_outputs=10):
  """
  Build a simple Feedforward Neural Network with at least 3 layers to consume 
  inputs and return a logits vector of n_outputs classes.  
  
  Note: any usage of tf.contrib.slim prebuilt layers is invalid. 
  """
  # TODO: implement your model here
  return None