from tensorflow.keras import Sequential
from tensorflow.keras.layers import (Dense, Flatten)

SEED = 15121

def create_model(model_type='vgg', n_outputs=50):
	if model_type == 'naive':
		return _naive_model(n_outputs=n_outputs)
	if model_type == 'vgg':
		return _vgg_model(n_outputs=n_outputs)
	else:
		raise ValueError('model type \'{}\' is not valid'.format(model_type))

def _naive_model(n_outputs=50):
	"""Naive model using only 1 FC layer, no dropout. For reference purpose.
	
		Validation and Test accuracy should be around 26%. 
	"""

	# create model parameters same for train, test, val
	return Sequential([
		Flatten(),
		Dense(n_outputs ,activation='softmax')
	])


def _vgg_model(n_outputs=50):
	# input shape: (batch_size, 56, 56, 3)

	# TODO: something here
	return None