from __future__ import absolute_import
from __future__ import division
from __future__ import print_function

import tensorflow as tf

user_flags = []


def DEFINE_string(name, default_value, doc_string):
  tf.compat.v1.flags.DEFINE_string(name, default_value, doc_string)
  global user_flags
  user_flags.append(name)


def DEFINE_integer(name, default_value, doc_string):
  tf.compat.v1.flags.DEFINE_integer(name, default_value, doc_string)
  global user_flags
  user_flags.append(name)


def DEFINE_float(name, default_value, doc_string):
  tf.compat.v1.flags.DEFINE_float(name, default_value, doc_string)
  global user_flags
  user_flags.append(name)


def DEFINE_boolean(name, default_value, doc_string):
  tf.compat.v1.flags.DEFINE_boolean(name, default_value, doc_string)
  global user_flags
  user_flags.append(name)


def print_user_flags(line_limit=80):
  print("-" * 80)

  global user_flags
  FLAGS = tf.compat.v1.flags.FLAGS

  for flag_name in sorted(user_flags):
    value = "{}".format(getattr(FLAGS, flag_name))
    log_string = flag_name
    log_string += "." * (line_limit - len(flag_name) - len(value))
    log_string += value
    print(log_string)


def count_model_params(tf_variables):
  """Count the total number of parameters in a model.

  Args:
    tf_variables: list of all model variables.
  """
  total = 0
  for v in tf_variables:
    shape = v.get_shape()
    variable_parameters = 1
    for dim in shape:
      variable_parameters *= dim.value
    total += variable_parameters
  print("Total number of parameters: " + str(total))
  return 0
