from __future__ import absolute_import
from __future__ import division
from __future__ import print_function

import pickle

import tensorflow as tf

N_CLASSES_LIMIT = 10


def pickle_load_data_dict(path='data_dict.pickle'):
  with open(path, 'rb') as handle:
    data_dict = pickle.load(handle)
  print("\n\nData loaded successfully from: {}\n\n".format(path))
  return data_dict


def _pre_process(img, label):
  """Process image only, input should be Tensors"""
  img = tf.pad(img, [[4, 4], [4, 4], [0, 0]])
  img = tf.image.random_crop(img, [56, 56, 3])
  img = tf.image.random_flip_left_right(img)
  img = tf.image.random_brightness(img, max_delta=63)
  img = tf.image.random_contrast(img, lower=0.2, upper=1.8)
  return img, label


def _parse_function(filename, label):
  """Read filepath into TF Tensors"""
  image_string = tf.io.read_file(filename)
  image_decoded = tf.image.decode_jpeg(image_string, channels=3)
  image_decoded = tf.cast(image_decoded, tf.float32)
  image_resized = tf.image.resize_with_crop_or_pad(image_decoded, 56, 56)

  return image_resized, label



def do_something_with_data_dict(data_dict):
  # TODO: maybe do something useful here
  data_dict = data_dict
  return data_dict

def create_batch_tf_dataset(data_dict,
                            batch_size=32,
                            n_workers=10,
                            buffer_size=10000):

  # TODO: (suggestion) maybe analyze and do something with data_dict first
  # ... calling do_something_with_data_dict() maybe ?

  # data augmentation is needed for train dataset
  train_imgs = tf.constant(data_dict["train_imgs"])
  train_labels = tf.constant(data_dict["train_labels"])

  # TODO: something

  # val dataset
  val_imgs = tf.constant(data_dict["val_imgs"])
  val_labels = tf.constant(data_dict["val_labels"])

  # TODO: something

  # test dataset
  test_imgs = tf.constant(data_dict["test_imgs"])
  test_labels = tf.constant(data_dict["test_labels"])

  # TODO: something

  return {
    "train": None,
    "valid": None,
    "test": None
  }


if __name__ == "__main__":
  data_dict = pickle_load_data_dict('data_dict.pickle')
  # dataset_dict = create_batch_tf_dataset(data_dict)

  # pause and observe
  import pdb; pdb.set_trace()
